# -*- coding: utf-8 -*-

def iscyrillic(c):
    return ord(c) >= 1040 and ord(c) <= 1103

def islatin(c):
    return ord(c) <= 122

def findbetween(string, start, end, notbefore, offset):
    i = string.find(start, offset)
    if i == -1:
        return [-1, '', 0]
    if notbefore != '':
        k = string.find(notbefore, offset)
        if k != -1 and k < i:
            return [-1, '', 0]
    j = string.find(end, i+1)
    if j == -1:
        return [i, string[i+len(start):len(string)].strip(), 1]
    return [i, string[i+len(start):j].strip(), 2]

def removebetweennums(string, i, j, victim):
    numremoved = 0
    while True:
        k = string.find(victim, i, j)
        if k == -1:
            break
        string = string[0:k] + string[k+len(victim):len(string)]
        numremoved = numremoved + 1
        j = j - len(victim)
        i = k+1
    return [numremoved, string]

def removebetween(string, start, end, victim):
    i = 0
    while True:
        i = string.find(start, i)
        if i == -1:
            break
        j = string.find(end, i+1)
        if j == -1:
            j = len(string)
        r = removebetweennums(string, i + len(start), j, victim)
        string = r[1]
        i = j+1-r[0]*len(victim)
    return string

def removeall(string, victim):
    r = removebetweennums(string, 0, len(string), victim)
    return r[1]

def removebetweeninclusive(string, start, end):
    i = 0
    while True:
        i = string.find(start, i)
        if i == -1:
            break
        j = string.find(end, i+1)
        if j == -1:
            j = len(string)
        string = string[0:i] + string[j:len(string)]
        i = i+1
    return string

def forcespaceafter(string, seek, killend):
    i = 0
    while True:
        i = string.find(seek, i+1)
        if i == -1:
            break
        elif i == len(string)-1:
            if killend:
                string = string[0:i]
            break

        if string[i+1] != ' ':
            string = string[0:i+1] + ' ' + string[i+1:len(string)]
        while i > 0 and string[i-1] == ' ':
            string = string[0:i-1] + string[i:len(string)]
            i = i - 1
    return string

def enclose(string, start, end, encstart, encend):
    offset = 0
    while True:
        i = string.find(start, offset)
        if i == -1:
            break
        j = string.find(end, i)
        if j == -1:
            j = len(string)
        string = string[0:i] + encstart + string[i:j] + encend + string[j:len(string)]
        offset = i + len(encstart) + 1
    return string

def inserttip(string, word, tipid):
    string = string.replace(' ' + word + ' ', ' <a href="#" onmouseout="popUp(event,\'' + tipid + \
        '\')" onmouseover="popUp(event,\'' + tipid + '\')"  onclick="return false">' + word + '</a> ')
    string = string.replace(' ' + word + ',', ' <a href="#" onmouseout="popUp(event,\'' + tipid + \
        '\')" onmouseover="popUp(event,\'' + tipid + '\')"  onclick="return false">' + word + '</a>,')
    return string

def inserttips(string, tips):
    for k, v in tips.iteritems():
        string = inserttip(string, k, k)
    return string

def fixstress(html):
    i = 0
    while True:
        i = html.find("'", i)
        if i == -1:
            break
        if iscyrillic(html[i-1]):
            html = html[0:i-1] + '<i>' + html[i-1] + '</i>' + html[i+1:len(html)]
        else:
            i = i+1
    p = 'е"'.decode('utf-8')
    q = 'ё'.decode('utf-8')
    while True:
       i = html.find(p)
       if i == -1:
           break
       html = html[0:i] + '<i>' + q + '</i>' + html[i+2:len(html)]
    return html
